#include "t3f/t3f.h"
#include "instance.h"
#include "defines.h"

WL_INSTANCE * wl_create_instance(void)
{
  WL_INSTANCE * ip;

  ip = malloc(sizeof(WL_INSTANCE));
  if(!ip)
  {
    goto fail;
  }
  memset(ip, 0, sizeof(WL_INSTANCE));
  ip->state = WL_STATE_TITLE;
  ip->current_menu = WL_MENU_MAIN;
  ip->last_menu = WL_MENU_MAIN;
  ip->last_item = -1;
  ip->leaderboard_spot = -1;
  ip->game_tutorial_sprite = -1;
  ip->tutorial_text_offset_x = WL_BOARD_X + 16;
  ip->tutorial_text_offset_y = WL_BOARD_Y + ((WL_MAX_BOARD_HEIGHT / 2) * WL_BOARD_TILE_SIZE + WL_BOARD_TILE_SIZE / 2);
  ip->tutorial_text_width = WL_MAX_BOARD_WIDTH * WL_BOARD_TILE_SIZE - 32;
  ip->graphics_scale = 1.0;
  ip->dead_zone = WL_DEFAULT_CONTROLLER_DEAD_ZONE;
  ip->exit_tick = -1;

  return ip;

  fail:
  {
    return NULL;
  }
}

void wl_destroy_instance(WL_INSTANCE * ip)
{
  free(ip);
}
