#ifndef WL_EFFECTS_H
#define WL_EFFECTS_H

#include "t3f/t3f.h"

typedef struct
{
  ALLEGRO_COLOR fade_start_color;
  ALLEGRO_COLOR fade_end_color;
  ALLEGRO_COLOR fade_current_color;
  int fade_time;
  int fade_last_tick;
  int fade_tick;
  bool fading;
} WL_EFFECTS_DATA;

WL_EFFECTS_DATA * wl_create_effects_data(void);
void wl_destroy_effects_data(WL_EFFECTS_DATA * dp);

ALLEGRO_COLOR wl_fade_color(ALLEGRO_COLOR c1, ALLEGRO_COLOR c2, float amount);
ALLEGRO_COLOR wl_darken_color(ALLEGRO_COLOR c1, float amount);
ALLEGRO_COLOR wl_alpha_color(ALLEGRO_COLOR c1, float alpha);

void wl_fade_to(WL_EFFECTS_DATA * dp, ALLEGRO_COLOR start_color, ALLEGRO_COLOR end_color, int time);
void wl_stop_fade(WL_EFFECTS_DATA * dp);
void wl_process_effects(WL_EFFECTS_DATA * dp);
void wl_render_effects(WL_EFFECTS_DATA * dp);

#endif
