#ifndef WL_INPUT_H
#define WL_INPUT_H

#define WL_INPUT_TYPE_MOUSE    0
#define WL_INPUT_TYPE_TOUCH    1
#define WL_INPUT_TYPE_GAMEPAD  2
#define WL_INPUT_TYPE_KEYBOARD 3

typedef struct
{

  bool pressed;
  bool released;
  bool held;

} WL_INPUT_BUTTON_STATE;

typedef struct
{

  float x;
  float y;

} WL_INPUT_POINTER_STATE;

typedef struct
{

  /* buttons */
  WL_INPUT_BUTTON_STATE up;
  WL_INPUT_BUTTON_STATE down; 
  WL_INPUT_BUTTON_STATE left;
  WL_INPUT_BUTTON_STATE right;
  WL_INPUT_BUTTON_STATE action;
  WL_INPUT_BUTTON_STATE cancel;
  WL_INPUT_BUTTON_STATE pause;

  /* pointer */
  WL_INPUT_POINTER_STATE pointer;

} WL_INPUT_STATE;

int wl_get_default_input_type(void);
void wl_select_input(int type, int device, void * data);
void wl_read_user_input(void * data);

#endif
