#ifndef WL_MUSIC_QUEUE_H
#define WL_MUSIC_QUEUE_H

#include "data.h"

#define WL_MUSIC_QUEUE_MAX_SIZE            8

#define WL_MUSIC_QUEUE_STATE_OFF           0
#define WL_MUSIC_QUEUE_STATE_PLAYING       1
#define WL_MUSIC_QUEUE_STATE_TRANSITIONING 2

#define WL_MUSIC_FADE_SPEED (1.0 / WL_LEVEL_FADE_FRAMES)

typedef struct
{

  char music_queue_fn[WL_MUSIC_QUEUE_MAX_SIZE][256];
  int music_queue_size;
  int music_queue_state;
  float music_fade_level;
  float music_fade_speed;
  float base_volume;

} WL_MUSIC_QUEUE;

WL_MUSIC_QUEUE * wl_create_music_queue(void);
void wl_destroy_music_queue(WL_MUSIC_QUEUE * qp);

void wl_clear_music_queue(WL_MUSIC_QUEUE * qp);
bool wl_play_music(WL_MUSIC_QUEUE * qp, const char * fn);
bool wl_queue_music(WL_MUSIC_QUEUE * qp, const char * fn);
void wl_finish_current_song(WL_MUSIC_QUEUE * qp, float fade_speed);
void wl_process_music_queue(WL_MUSIC_QUEUE * qp);
int wl_get_music_queue_state(WL_MUSIC_QUEUE * qp);
void wl_set_music_fade_speed(WL_MUSIC_QUEUE * qp, float speed);
void wl_set_music_base_volume(WL_MUSIC_QUEUE * qp, float vol);

#endif
