#ifndef WL_SHAPE_H
#define WL_SHAPE_H

#include "t3f/t3f.h"
#include "defines.h"
#include "level.h"

typedef struct
{
	
	ALLEGRO_VERTEX v;
	int flags;
	
} WL_VERTEX;

typedef struct
{
	
	ALLEGRO_VERTEX vertex[WL_MAX_VERTICES];
	int vertices;
//	ALLEGRO_BITMAP * bp;
	ALLEGRO_BITMAP ** parent_bp;
	float ox, oy, oz;
	float vx, vy;
	float slope;
	int flags;
	
} WL_SHAPE;

typedef struct
{

	WL_SHAPE * bg_shape;
	WL_SHAPE * fg_shape;
	int shapes;

	WL_SHAPE ** cached_shape[2];
	int cached_shapes[2];

} WL_SHAPE_LISTS;

void wl_generate_shape(WL_SHAPE * sp, WL_LEVEL_SHAPE * lsp, ALLEGRO_BITMAP ** parent_bp, float x, float y, float z, float slope);
void wl_connect_shape(WL_SHAPE * sp1, WL_SHAPE * sp2, WL_LEVEL_SHAPE * lsp, ALLEGRO_BITMAP ** parent_bp);
void wl_process_shape(WL_SHAPE * sp);
void wl_draw_shape(WL_SHAPE * sp, ALLEGRO_COLOR color, int flags);

WL_SHAPE_LISTS * wl_create_shape_lists(int max);
void wl_destroy_shape_lists(WL_SHAPE_LISTS * lp);
void wl_cache_shape(WL_SHAPE_LISTS * lp, int list, WL_SHAPE * sp);
void wl_draw_cached_shapes(WL_SHAPE_LISTS * lp, int list, ALLEGRO_COLOR color);
void wl_clear_cached_shapes(WL_SHAPE_LISTS * lp, int list);

#endif
