#include "t3f/t3f.h"
#include "instance.h"

void wl_load_preferences(void * data)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;
	const char * val;

	/* set default options */
	instance->option[WL_OPTION_CONTROLS] = 0;
	instance->option[WL_OPTION_MUSIC_VOLUME] = 100;
	instance->option[WL_OPTION_SOUND_VOLUME] = 100;
	instance->option[WL_OPTION_UPLOAD_SCORES] = 1;
	instance->option[WL_OPTION_FIRST_RUN] = 1;
	instance->option[WL_OPTION_DISABLE_CENSORSHIP] = 0;
	instance->option[WL_OPTION_VIDEO_MODE] = 0;

	/* load config file */
	val = al_get_config_value(t3f_config, "Config", "Video Mode");
	if(val)
	{
		instance->option[WL_OPTION_VIDEO_MODE] = atoi(val);
		if(instance->option[WL_OPTION_MUSIC_VOLUME] < 0 || instance->option[WL_OPTION_MUSIC_VOLUME] > 200)
		{
			instance->option[WL_OPTION_MUSIC_VOLUME] = 100;
		}
	}
	val = al_get_config_value(t3f_user_data, "Preferences", "Music Volume");
	if(val)
	{
		instance->option[WL_OPTION_MUSIC_VOLUME] = atoi(val);
		if(instance->option[WL_OPTION_MUSIC_VOLUME] < 0 || instance->option[WL_OPTION_MUSIC_VOLUME] > 200)
		{
			instance->option[WL_OPTION_MUSIC_VOLUME] = 100;
		}
	}
	val = al_get_config_value(t3f_user_data, "Preferences", "Sound Volume");
	if(val)
	{
		instance->option[WL_OPTION_SOUND_VOLUME] = atoi(val);
		if(instance->option[WL_OPTION_SOUND_VOLUME] < 0 || instance->option[WL_OPTION_SOUND_VOLUME] > 200)
		{
			instance->option[WL_OPTION_SOUND_VOLUME] = 100;
		}
	}
	val = al_get_config_value(t3f_user_data, "Preferences", "Upload Scores");
	if(val)
	{
		instance->option[WL_OPTION_UPLOAD_SCORES] = atoi(val);
		if(instance->option[WL_OPTION_UPLOAD_SCORES] < 0)
		{
			instance->option[WL_OPTION_UPLOAD_SCORES] = 1;
		}
	}
	val = al_get_config_value(t3f_user_data, "Preferences", "Disable Censorship");
	if(val)
	{
		instance->option[WL_OPTION_DISABLE_CENSORSHIP] = atoi(val);
	}
	val = al_get_config_value(t3f_user_data, "Preferences", "First Run");
	if(val)
	{
		instance->option[WL_OPTION_FIRST_RUN] = atoi(val);
	}
	t3f_set_sound_volume((float)instance->option[WL_OPTION_SOUND_VOLUME] / 100.0);
}

void wl_save_preferences(void * data)
{
	WL_INSTANCE * instance = (WL_INSTANCE *)data;
	char buf[256];

	sprintf(buf, "%d", instance->option[WL_OPTION_VIDEO_MODE]);
	al_set_config_value(t3f_config, "Config", "Video Mode", buf);
	sprintf(buf, "%d", instance->option[WL_OPTION_MUSIC_VOLUME]);
	al_set_config_value(t3f_user_data, "Preferences", "Music Volume", buf);
	sprintf(buf, "%d", instance->option[WL_OPTION_SOUND_VOLUME]);
	al_set_config_value(t3f_user_data, "Preferences", "Sound Volume", buf);
	sprintf(buf, "%d", instance->option[WL_OPTION_UPLOAD_SCORES]);
	al_set_config_value(t3f_user_data, "Preferences", "Upload Scores", buf);
	sprintf(buf, "%d", instance->option[WL_OPTION_DISABLE_CENSORSHIP]);
	al_set_config_value(t3f_user_data, "Preferences", "Disable Censorship", buf);
	sprintf(buf, "%d", instance->option[WL_OPTION_FIRST_RUN]);
	al_set_config_value(t3f_user_data, "Preferences", "First Run", buf);
}
